(* Programma per riscrivere i hat in termini di funzioni seno e coseno *)


hattosine[f_Times] :=
           hattosine /@ f

hattosine[f_Plus] :=
    If[ Length[f] == 2 && faseQ[f[[1]]] && faseQ[f[[2]]],
        hattosine1[f],
        hattosine /@ f
      ]
hattosine[f_] := 
          f /; !MemberQ[{Plus,Times}, Head[f]]





hattosine1[d_ + Cexp[a_,e_] Cexp[b_,e_] c___ ] :=
                            hattosine1[d + Cexp[a + b,e] c ]

hattosine1[-1 + a_] := 
                - hattosine1[1 - a]

hattosine1[1 - Cexp[b_,c_]] :=
                   -2 im s2[b,c] phi2[b,c]

hattosine1[1 + Cexp[b_,c_]] :=
                      2 c2[b,c] phi2[b,c]

hattosine1[-a_ - b_] :=
                 - hattosine1[a + b]

hattosine1[Cexp[a_,b_] + Cexp[c_,b_]] :=
                     2 c2[a - c,b] phi2[a + c,b]


hattosine1[Cexp[a_,b_] - Cexp[c_,b_]] :=
                     2 im s2[a - c,b] phi2[a + c,b]
hattosine1[a_] := a




faseQ[1] = True

faseQ[-1] = True

faseQ[a_ b_] := faseQ[a] && faseQ[b]

faseQ[Cexp[___]] = True

faseQ[_] = False



s2[-a_,b_] := - s2[a,b]
s2[0,a_] = 0
c2[-a_,b_] := c2[a,b]
c2[0,a_] := delm[a,a]
phi2[0,a_] := delm[a,a]
(* c2[0,a_] = 1
   phi2[0,a_] = 1 *)
phi2[a_,-rho[b_]] := phi2[-a,rho[b]]
phi2[a_,-mu[b_]] := phi2[-a,mu[b]]
phi2[a_,-nu[b_]] := phi2[-a,nu[b]]

s2overs2[d_, -a_, b_] := s2overs2[d,a,b]

collectphases[f_] :=
    f //. {phi2[a_,b_] phi2[c_,b_] :> phi2[a + c,b],
           c_ phi2[a_,b_] + d_ phi2[a_,b_] :> (c + d) phi2[a,b]}




canonicalOld[f_] := f /.  phi2[x_,y_] :> phi2[Expand[x],y] /.
                       s2[x_,y_] :> If[!OrderedQ[{Expand[x],Expand[-x]}],
                                       s2[Expand[x],y],
                                       -s2[Expand[-x],y]
                                      ] /.
                       c2[x_,y_] :> If[!OrderedQ[{Expand[x],Expand[-x]}],
                                       c2[Expand[x],y],
                                       c2[Expand[-x],y]
                                      ] /.
                       prop[x_,y__] :> If[!OrderedQ[{Expand[x],Expand[-x]}],
                                       prop[Expand[x],y],
                                       prop[Expand[-x],y]
                                      ] /.
                       dprop[x_,y__] :> If[!OrderedQ[{Expand[x],Expand[-x]}],
                                       dprop[Expand[x],y],
                                       dprop[Expand[-x],y]
                                      ] /.
                       omegaO[x_,y___] :> If[!OrderedQ[{Expand[x],Expand[-x]}],
                                       omegaO[Expand[x],y],
                                       omegaO[Expand[-x],y]
                                      ] /.
                       omegainvO[x_,y___] :> If[!OrderedQ[{Expand[x],Expand[-x]}],
                                       omegainvO[Expand[x],y],
                                       omegainvO[Expand[-x],y]
                                      ] /.
                       omegabO[x_,y___] :> If[!OrderedQ[{Expand[x],Expand[-x]}],
                                       omegabO[Expand[x],y],
                                       omegabO[Expand[-x],y]
                                      ] /.
                       omegabinvO[x_,y___] :> If[!OrderedQ[{Expand[x],Expand[-x]}],
                                       omegabinvO[Expand[x],y],
                                       omegabinvO[Expand[-x],y]
                                      ] /.
                       omegaplusinvO[x_,y_] :> If[!OrderedQ[{Expand[x],Expand[-x]}],
                                       omegaplusinvO[Expand[x],y],
                                       omegaplusinvO[Expand[-x],y]
                                      ] /.
                       omegaplusinvO[x_,y_] :> If[!OrderedQ[{Expand[y],Expand[-y]}],
                                       omegaplusinvO[x,Expand[y]],
                                       omegaplusinvO[x,Expand[-y]]
                                      ] /.
                       delta[x_] :> If[!OrderedQ[{Expand[x],Expand[-x]}],
                                       delta[Expand[x]],
                                       delta[Expand[-x]]
                                     ] /.
                       hat2[x_] :> If[!OrderedQ[{Expand[x],Expand[-x]}],
                                       hat2[Expand[x]],
                                       hat2[Expand[-x]]
                                     ] /.
                       fhat[x_,y___] :> If[!OrderedQ[{Expand[x],Expand[-x]}],
                                           fhat[Expand[x],y],
                                           fhat[Expand[-x],y]
                                          ] /.
                       sisq[x_] :> If[!OrderedQ[{Expand[x],Expand[-x]}],
                                      sisq[Expand[x]],
                                      sisq[Expand[-x]]
                                     ] /.
                       s2sq[x_] :> If[!OrderedQ[{Expand[x],Expand[-x]}],
                                      s2sq[Expand[x]],
                                      s2sq[Expand[-x]]
                                     ] /.
                       s2qu[x_] :> If[!OrderedQ[{Expand[x],Expand[-x]}],
                                      s2qu[Expand[x]],
                                      s2qu[Expand[-x]]
                                     ] /.
                       s2overs2[a_,x_,y_] :> If[!OrderedQ[{Expand[x],Expand[-x]}],
                                      s2overs2[a,Expand[x],y],
                                      s2overs2[a,Expand[-x],y]
                                     ] /.
                       mO[x_] :> If[!OrderedQ[{Expand[x],Expand[-x]}],
                                      mO[Expand[x]],
                                      mO[Expand[-x]]
                                     ] /.
                       m[x_] :> If[!OrderedQ[{Expand[x],Expand[-x]}],
                                   m[Expand[x]],
                                   m[Expand[-x]]
                                  ]

canonical[f_] := f /.  
   s2[x_,y_]             :> If[!OrderedQ[{Expand[x],Expand[-x]}],
                               s2[Expand[x],y],
                               -s2[Expand[-x],y]] /.
   c2[x_,y_]             :> c2[Sort[{Expand[x],Expand[-x]}][[2]],y] /.
   S2[x_,y_]             :> If[!OrderedQ[{Expand[x],Expand[-x]}],
                               S2[Expand[x],y],
                               -S2[Expand[-x],y]] /.
   C2[x_,y_]             :> C2[Sort[{Expand[x],Expand[-x]}][[2]],y] /.
   prop[x_,y__]          :> prop[Sort[{Expand[x],Expand[-x]}][[2]],y] /.
   dprop[x_,y__]         :> dprop[Sort[{Expand[x],Expand[-x]}][[2]],y] /.
   omegaO[x_]            :> omegaO[Sort[{Expand[x],Expand[-x]}][[2]]] /.
   omegainvO[x_]         :> omegainvO[Sort[{Expand[x],Expand[-x]}][[2]]] /.
   omegabO[x_]           :> omegabO[Sort[{Expand[x],Expand[-x]}][[2]]] /.
   omegabinvO[x_]        :> omegabinvO[Sort[{Expand[x],Expand[-x]}][[2]]] /.
   omegaplusinvO[x_,y__] :> omegaplusinvO[Sort[{Expand[x],Expand[-x]}][[2]],y] /.
   omegaplusinvO[x__,y_] :> omegaplusinvO[x,Sort[{Expand[y],Expand[-y]}][[2]]] /.
   delta[x_]             :> delta[Sort[{Expand[x],Expand[-x]}][[2]]] /.
   deltaMod2[x_]         :> deltaMod2[Sort[{Expand[x],Expand[-x]}][[2]]] /.
   hat2[x_,y___]         :> hat2[Sort[{Expand[x],Expand[-x]}][[2]],y] /.
   fhat[x_,y___]         :> fhat[Sort[{Expand[x],Expand[-x]}][[2]],y] /.
   fhatSF[x_,y___]       :> fhatSF[Sort[{Expand[x],Expand[-x]}][[2]],y] /.
   sisq[x_]              :> sisq[Sort[{Expand[x],Expand[-x]}][[2]]] /.
   s2sq[x_]              :> s2sq[Sort[{Expand[x],Expand[-x]}][[2]]] /.
   s2qu[x_]              :> s2qu[Sort[{Expand[x],Expand[-x]}][[2]]] /.
   mO[x_]                :> mO[Sort[{Expand[x],Expand[-x]}][[2]]] /.
   m[x_]                 :> m[Sort[{Expand[x],Expand[-x]}][[2]]] /.
   prod[x_]              :> If[!OrderedQ[{Expand[x],Expand[-x]}],
                               prod[Factor[Expand[x]]],
                               -prod[Factor[Expand[-x]]]]    

hat2[-a_] := hat2[a]
fhat[-a_,b___] := fhat[a,b]
fhatSF[-a_,b___] := fhatSF[a,b]
m[-a_] := m[a]

count/: count[expr_,a_] := 
            Switch[Head[expr], Power, If[MatchQ[expr[[1]],a],expr[[2]],0],
                               Times, Plus @@ (count[#,a]& /@ (List@@expr)),
                               _,     If[MatchQ[expr,a],1,0]]

countlist[a_,b_]:= If[Head[b]===List,Plus @@((count[a,#[[1]]] #[[2]])& /@ b) ,count[a,b]]
             
(* periodic riporta l'espressione ad una forma simmetrica negli
   impulsi *)
             

periodic[f_Plus] :=
                periodic /@ f

periodic[f_] := Block[{f1},
    f1 = f //. s2[p[a_],b_]^i_. c2[p[a_],b_]^j_. :> s2[2p[a],b] / 2 *
                                  s2[p[a],b]^(i-1) c2[p[a],b]^(j-1) ;
    f1 = antisymmetrize[f1];
    f1 = rorder[porder[f1]];
    f1 = Expand[f1 /. {s2[a_ + b_,c_] :> s2[a,c] c2[b,c] + c2[a,c] s2[b,c],
                       c2[a_ + b_,c_] :> c2[a,c] c2[b,c] - s2[a,c] s2[b,c]}];
    f1 = f1 //. s2[p[a_],b_]^i_. c2[p[a_],b_]^j_. :> s2[2p[a],b] / 2 *
                                  s2[p[a],b]^(i-1) c2[p[a],b]^(j-1) ;
    f1 = antisymmetrize[f1];
    f1 = rorder[porder[f1]];
    f1 = Expand[f1 //. {s2[p[a_],b_]^i_ :> (1 - c2[2p[a],b]) / 2 * s2[p[a],b]^(i-2),
                       c2[p[a_],b_]^i_ :> (1 + c2[2p[a],b]) / 2 * c2[p[a],b]^(i-2)}];
    f1 = antisymmetrize[f1];
    f1 = rorder[porder[f1]]      ]




