(* These functions can be applied to the whole of an expression,
   in order to simplify cosines;
   the Head of the expression must be Plus in order to maximize
   the instances in which such simplifications will take place   *)

replacec2p[a_Plus]:= replacec2p /@ a

replacec2p[c2[a_,b_]^i_ c_.]:= 
     replace[c2[a,b]^i c, {c2[a,b]^i, c2[a,b]^(i-2)}] -
      c2[a,b]^(i-2) s2[a,b]^2 c

replacec2p[c2[2 a_,b_] c_.]:=
     replace[c2[2a,b] c, {c2[2a,b],1}] - 2 canonical[s2[a,b]]^2 c

replacec2p[c2[4 a_,b_] c_.]:=
     replace[c2[4a,b] c, {c2[4a,b],1}] - 2 canonical[s2[2a,b]]^2 c

replacec2p[a_]:= a


(* Can be applied to the expression as a whole, which must have Head = Plus *)

replacec2[a_Plus]:= replacec2 /@ a

(* We will omit the following, because it leads to expression which are not
   expanded, and this may lead to subsequent mistakes                       *)

(* replacec2[a_Times]:= Select[a,(FreeQ[#,c2] && FreeQ[#,rho])&] *
              replacec2[Expand[Select[a,(!(FreeQ[#,c2]&&FreeQ[#,rho]))&]]] /; 
              (Or @@ ((FreeQ[#,c2]&&FreeQ[#,rho])& /@ List @@ a))           *)

replacec2[c2[a_. q[j_],b_]^i_ c_.]:= 
     replace[c2[a q[j],b]^i c, {c2[a q[j],b]^i, c2[a q[j],b]^(i-2)}] -
      c2[a q[j],b]^(i-2) s2[q[j],b]^2 a^2 c

replacec2[c2[a_. q[j_],b_] c_.]:=
     replace[c2[a q[j],b] c, {c2[a q[j],b],1}] - (a^2)/2 s2[q[j],b]^2 c

replacec2[a_]:= a



(* Can be applied to the expression as a whole, which must have Head = Plus *)

replacec2exact[a_Plus]:= replacec2exact /@ a

(* We will omit the following, because it leads to expression which are not
   expanded, and this may lead to subsequent mistakes                       *)

(* replacec2exact[a_Times]:= Select[a,(FreeQ[#,c2] && FreeQ[#,rho])&] *
              replacec2exact[Expand[Select[a,(!(FreeQ[#,c2]&&FreeQ[#,rho]))&]]] /; 
              (Or @@ ((FreeQ[#,c2]&&FreeQ[#,rho])& /@ List @@ a))           *)

replacec2exact[c2[a_. q[j_],b_]^i_ c_.]:= 
     replace[c2[a q[j],b]^i c, {c2[a q[j],b]^i, c2[a q[j],b]^(i-2)}] -
      c2[a q[j],b]^(i-2) s2[a q[j],b]^2 c

replacec2exact[c2[a_. q[j_],b_] c_.]:=
     replace[c2[a q[j],b] c, {c2[a q[j],b],1}] - 2 s2[a q[j]/2,b]^2 c

replacec2exact[a_]:= a
