(* The functions 'symmetrizeauto', 'symmetrize', 'symmetrizepartially'
   are meant for internal use of the function 'contract'.
   Given a vertex which contains several identical fields (typically gluons),
   these functions symmetrize the vertex w.r.t. these fields (only to the extent
   that is needed, for the sake of economy).
   
symmetrizeauto[ vertex_, min_, max_] := vertex /; 
                                       !(OddQ[max-min] && max-min > 0)
symmetrizeauto[ vertex_, min_, max_] := vertex /; min+1==max
symmetrizeauto[ vertex_, min_, max_] := 
  symmetrizeauto[vertex + Sum[vertex  /. {k[max-1] -> k[ij], k[ij] -> k[max-1], 
                                            mu[max-1] -> mu[ij], mu[ij] -> mu[max-1],
                                            c[max-1] -> c[ij], c[ij] -> c[max-1]},
                               {ij, min, max-2} ], 
                 min, max-2 ]  / (max-min)


symmetrize[ vertex_, min_, max_] := vertex /; min>=max
symmetrize[ vertex_, min_, max_] := 
  symmetrize[vertex + Sum[vertex  /. {k[max] -> k[ij],  k[ij] -> k[max], 
                                        mu[max]-> mu[ij], mu[ij]-> mu[max],
                                        c[max] -> c[ij],  c[ij] -> c[max]},
                           {ij, min, max-1} ], 
             min, max-1 ]  / (max-min+1)

symmetrizepartially[ vertex_, listOfGroups_ ]:=
     symmetrizepartially[ vertex, listOfGroups, 0]
symmetrizepartially[ vertex_, listOfGroups_, offset_]:= 
     vertex /;                                        Length[listOfGroups] == 1

symmetrizepartially[ vertex_, listOfGroups_, offset_] := 
     symmetrizepartially[ vertex, Drop[ listOfGroups, -1], offset] /;
                                                        Last[listOfGroups ] == 0

symmetrizepartially[ vertex_, listOfGroups_, offset_] := 
     symmetrizepartially[ symmetrizepartially1[ vertex, 
                                                Plus@@listOfGroups, 
                                                Plus@@listOfGroups,
                                                Last[listOfGroups], offset],
                          Drop[ listOfGroups, -1], offset] /
     Binomial[ Plus@@listOfGroups, Last[listOfGroups] ]



symmetrizepartially1[ vertex_, maxvalue_, lastindex_, 0 , offset_] := vertex

symmetrizepartially1[ vertex_, maxvalue_, lastindex_, indexnumber_, offset_] :=
  Plus@@Array[
    (symmetrizepartially1[
       vertex /. {k[offset+lastindex] -> k[offset+#+indexnumber-1],
                   k[offset+#+indexnumber-1] -> k[offset+lastindex],
                   c[offset+lastindex] -> c[offset+#+indexnumber-1],
                   c[offset+#+indexnumber-1] -> c[offset+lastindex],
                   mu[offset+lastindex] -> mu[offset+#+indexnumber-1],
                   mu[offset+#+indexnumber-1] -> mu[offset+lastindex]},
                   #+indexnumber-2, 
                   lastindex - 1, 
                   indexnumber - 1,
                   offset]
       )& , maxvalue-indexnumber+1 ]       
 
